﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace TestCommands
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            m_DispatcherTimer = new DispatcherTimer()
            {
                Interval = TimeSpan.FromSeconds(0.25),
                IsEnabled = true
            };
            m_DispatcherTimer.Tick += delegate
            {
                CommandManager.InvalidateRequerySuggested();
            };
        }

        DispatcherTimer m_DispatcherTimer;


        private void MyCommandCanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            DateTime now = DateTime.Now;
            if (CanExecuteOutput != null)
            {
                CanExecuteOutput.Text = "MyCommand CanExecute determined at " + now.ToLongTimeString() + " (and " + now.Millisecond + "ms)";
            }
            e.CanExecute = DateTime.Now.Second % 2 == 0;
        }

        private void MyCommandExecuted(object sender, ExecutedRoutedEventArgs e)
        {
            TextOutput.Text = "MyCommand executed at " + DateTime.Now.ToLongTimeString();
        }
    }
}
